import json

from PIL import Image, ImageDraw, ImageFont

def drawImage(channel):
    with open("resources/games/games.json", "r") as f:
        data = json.load(f)

    fnt = ImageFont.truetype('resources/futura-bold.ttf', 50)

    table = Image.open("resources/games/blackjackTable.png")
    placement = [2,1,3,0,4]
    textImage = ImageDraw.Draw(table)
    hands = data["blackjack games"][channel]["user hands"]

    dealerBusted = data["blackjack games"][channel]["dealer busted"]
    dealerBlackjack = data["blackjack games"][channel]["dealer blackjack"]
    
    if data["blackjack games"][channel]["all standing"] == False:
        dealerHand = drawHand(data["blackjack games"][channel]["dealer hand"],True,False,False)
    else:
        dealerHand = drawHand(data["blackjack games"][channel]["dealer hand"],False,dealerBusted,dealerBlackjack)

    table.paste(dealerHand,(800,20),dealerHand)

    for x in range(len(hands)):
        key, value = list(hands.items())[x]
        userHand = drawHand(value["hand"],False,value["busted"],value["blackjack"])
        textWidth = fnt.getsize(key)[0]
        table.paste(userHand,(32+(384*placement[x]),680),userHand)
        textImage.text((32+(384*placement[x])+117-int(textWidth/2),1010),key,fill=(0,0,0), font=fnt)

    table.save("resources/games/tables/blackjackTable"+channel+".png")

    return

def drawHand(hand, dealer, busted, blackjack):
    fnt = ImageFont.truetype('resources/futura-bold.ttf', 200)
    fnt2 = ImageFont.truetype('resources/futura-bold.ttf', 120)
    length = len(hand)
    background = Image.new("RGBA", (691+(125*(length-1)),1065),(0,0,0,0))
    textImage = ImageDraw.Draw(background)

    if dealer:
        img = Image.open("resources/games/cards/"+hand[0].upper()+".png")
        background.paste(img,(0,0),img)
        img = Image.open("resources/games/cards/red_back.png")
        background.paste(img,(125,0),img)
    else:
        for x in range(length):
            img = Image.open("resources/games/cards/"+hand[x].upper()+".png")
            background.paste(img,(x*125,0),img)
    
    w, h = background.size

    if busted:
        textWidth = fnt.getsize("BUSTED")[0]
        textImage.text((int(w/2)-int(textWidth/2)-5,450-5),"BUSTED",fill=(0,0,0), font=fnt)
        textImage.text((int(w/2)-int(textWidth/2)+5,450-5),"BUSTED",fill=(0,0,0), font=fnt)
        textImage.text((int(w/2)-int(textWidth/2)-5,450+5),"BUSTED",fill=(0,0,0), font=fnt)
        textImage.text((int(w/2)-int(textWidth/2)+5,450+5),"BUSTED",fill=(0,0,0), font=fnt)
        textImage.text((int(w/2)-int(textWidth/2),430),"BUSTED",fill=(255,50,50), font=fnt)
    elif blackjack:
        textWidth = fnt2.getsize("BLACKJACK")[0]
        textImage.text((int(w/2)-int(textWidth/2)-5,450-5),"BLACKJACK",fill=(0,0,0), font=fnt2)
        textImage.text((int(w/2)-int(textWidth/2)+5,450-5),"BLACKJACK",fill=(0,0,0), font=fnt2)
        textImage.text((int(w/2)-int(textWidth/2)-5,450+5),"BLACKJACK",fill=(0,0,0), font=fnt2)
        textImage.text((int(w/2)-int(textWidth/2)+5,450+5),"BLACKJACK",fill=(0,0,0), font=fnt2)
        textImage.text((int(w/2)-int(textWidth/2),430),"BLACKJACK",fill=(255,223,0), font=fnt2)
    
    return background.resize((int(w/3.5),int(h/3.5)))
